using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;


namespace Canvas 
{
	public class Canvas
	{
        private int width;
        private int heigth;
        private int numberOfObjects;
        private int numberOfTempObjects;
        private Color backgroundColor;
        private Graphics g;
        private void CreateObject(int Nr, BasicObject.ObjectTyp Typ)
        {
            switch (Typ)
            {
            case BasicObject.ObjectTyp.Line:
            default:
                Figure[Nr] = new MyLine();
                break;
            case BasicObject.ObjectTyp.Ellypse:
                Figure[Nr] = new Ellypse();
                break;
            case BasicObject.ObjectTyp.Circle:
                Figure[Nr] = new Circle();
                break;
            case BasicObject.ObjectTyp.MyRectangle:
                Figure[Nr] = new MyRectangle();
                break;
            case BasicObject.ObjectTyp.Square:
                Figure[Nr] = new Square();
                break;
            case BasicObject.ObjectTyp.Quadrangle:
                Figure[Nr] = new Quadrangle();
                break;
            case BasicObject.ObjectTyp.Triangle:
                Figure[Nr] = new Triangle();
                break;
            }
        }
        private void CreateTempObject(int Nr, BasicObject.ObjectTyp Typ, int More)
        {
            switch (Typ)
            {
                case BasicObject.ObjectTyp.Line:
                default:
                    FigureTemp[Nr] = new MyLine();
                    break;
                case BasicObject.ObjectTyp.Ellypse:
                    FigureTemp[Nr] = new Ellypse();
                    break;
                case BasicObject.ObjectTyp.Circle:
                    FigureTemp[Nr] = new Circle();
                    break;
                case BasicObject.ObjectTyp.MyRectangle:
                    FigureTemp[Nr] = new MyRectangle();
                    break;
                case BasicObject.ObjectTyp.Square:
                    FigureTemp[Nr] = new Square();
                    break;
                case BasicObject.ObjectTyp.Quadrangle:
                    FigureTemp[Nr] = new Quadrangle();
                    break;
                case BasicObject.ObjectTyp.Triangle:
                    FigureTemp[Nr] = new Triangle();
                    break;
            }
        }
        private void CreateTempObject(int Nr, BasicObject.ObjectTyp Typ)
        {
            CreateTempObject(Nr, Typ, -1);
        }
        private GraficState state;
        public enum GraficState {grfNormal, grfDraw, grfSelect};
        public int Width
        {
            get
            {
                return width;
            }

        }
        public int Heigth
        {
            get
            {
                return heigth;
            }
        }
        public GraficState State
        {
            set
            {
                state = value;
            }
            get
            {
                return state;
            }
        }
        public Color BackgroundColor
        {
            get
            {
                return BackgroundColor;
            }
            set
            {
                backgroundColor = value;
            }
        }
        public BasicObject[] Figure;
        public BasicObject[] FigureTemp;
        public Canvas(int Width, int Heigth, Graphics gr)
        {
            const int cAnzahl=1000;     
            g = gr;
            width = Width;
            heigth = Heigth;
            State = GraficState.grfNormal;
            backgroundColor = Color.White;
            numberOfObjects = 0;
            numberOfTempObjects = 0;
            Figure = new BasicObject[cAnzahl];
            FigureTemp = new BasicObject[cAnzahl];
        }
        public void NewObject(BasicObject.ObjectTyp Value)
        {
            numberOfObjects++;
            CreateObject(numberOfObjects - 1, Value);
        }
        public void NewTempObject(BasicObject.ObjectTyp Value, bool Reset, int More)
        {
            if (Reset == true)
            {
                numberOfTempObjects = 0;
            }
            numberOfTempObjects++;
            CreateTempObject(numberOfTempObjects - 1, Value,More);
            FigureTemp[numberOfTempObjects - 1].State = BasicObject.StateTyp.shift;
        }
        public void NewTempObject(BasicObject.ObjectTyp Value, bool Reset)
        {
            if (Reset == true)
            {
                numberOfTempObjects = 0;
            }
            numberOfTempObjects++;
            CreateTempObject(numberOfTempObjects - 1, Value);
            FigureTemp[numberOfTempObjects - 1].State = BasicObject.StateTyp.shift;
        }
        public void DrawNew()
        {
             Brush Fuellung = new SolidBrush(backgroundColor);
             g.FillRectangle(Fuellung, 0, 0, Width, Heigth);
             for (int i = 0; i < numberOfObjects; i++)
             {
                 if (Figure[i].Visible==true)
                 {
                     Figure[i].Draw(g);
                 }
             }
        }
        public int NumberOfObjects
        {
            get
            {
                return numberOfObjects;
            }
        }
        public void DeselectAll()
        {
            for (int i = 0; i < NumberOfObjects; i++)
            {
                Figure[i].State = BasicObject.StateTyp.normal;
            }
        }
        public void ObjectToForeground(int Nr)
        {
            NewTempObject(Figure[Nr].GetTyp(), true);
            FigureTemp[0].Assign(Figure[Nr]);
            for (int i = Nr; i < (NumberOfObjects-1); i++)
            {
                CreateObject(i, Figure[i + 1].GetTyp());
                Figure[i].Assign(Figure[i + 1]);
            }
            CreateObject(NumberOfObjects - 1, FigureTemp[0].GetTyp());
            Figure[NumberOfObjects - 1].Assign(FigureTemp[0]);
        }
        public void ObjectToBackground(int Nr)
        {
            NewTempObject(Figure[Nr].GetTyp(), true);
            FigureTemp[0].Assign(Figure[Nr]);
            for (int i = 0; i < Nr; i++)
            {
                CreateObject(Nr-i, Figure[Nr-i-1].GetTyp());
                Figure[Nr-i].Assign(Figure[Nr-i-1]);
            }
            CreateObject(0, FigureTemp[0].GetTyp());
            Figure[0].Assign(FigureTemp[0]);
        }
        public void ObjectOnePositionToBackground(int Nr)
        {
            if (Nr > 0)
            {
                NewTempObject(Figure[Nr].GetTyp(), true);
                FigureTemp[0].Assign(Figure[Nr]);
                
                CreateObject(Nr, Figure[Nr - 1].GetTyp());
                Figure[Nr].Assign(Figure[Nr - 1]);

                CreateObject((Nr - 1), FigureTemp[0].GetTyp());
                Figure[Nr - 1].Assign(FigureTemp[0]);
            }
        }
        public void ObjectOnePositionToForeground(int Nr)
        {
            if (Nr < (NumberOfObjects - 1))
            {
                NewTempObject(Figure[Nr].GetTyp(), true);
                FigureTemp[0].Assign(Figure[Nr]);
                CreateObject(Nr, Figure[Nr + 1].GetTyp());
                Figure[Nr].Assign(Figure[Nr + 1]);
                CreateObject((Nr + 1), FigureTemp[0].GetTyp());
                Figure[Nr + 1].Assign(FigureTemp[0]);
            }
        }
        public int[] SelectedObjects()
        {
            int anzahl = 0;
            int[] temp = new int[NumberOfObjects];
            for (int i = 0; i < NumberOfObjects; i++)
            {
                if (Figure[i].State != BasicObject.StateTyp.normal)
                {
                    anzahl++;
                    temp[anzahl - 1] = i;
                }
            }
            int[] markierteObjekte = new int[anzahl];
            Array.Copy(temp, markierteObjekte, anzahl);
            return markierteObjekte;
        }
        public int NumberOfSelectedObjects()
        {
            int number = 0;
            for (int i = 0; i < NumberOfObjects; i++)
            {
                if (Figure[i].State != BasicObject.StateTyp.normal)
                {
                    number++;
                }
            }
            return number;
        }
    }
}
